%define kver 2.6.9
%define krelmaj 78
%define krelmin 19
%define krpmver %{krelmaj}.%{krelmin}AXS2
%define drvsuff V580A1-1

Summary:       A320raid (Adaptec close source driver)
Name:          kernel-driver-a320raid
Version:       3.00.074
Release:       %{kver}_%{krpmver}_1
License:       proprietary
Group:         System Environment/Kernel
URL:           http://www.adaptec.com/
Source:        a320raid-src-%{version}-%{drvsuff}.tgz
Source1:       filter-requires-kernel.sh
Patch0:        a320raid-rhlikekernel.patch
Patch1:        a320raid-3.00.074-writebuffer.patch
NoSource:      0

BuildPreReq:   kernel-devel = %{kver}-%{krpmver}
BuildPreReq:   kernel-source = %{kver}-%{krpmver}
Prereq:        kernel-%{_target_cpu} = %{kver}-%{krpmver}

BuildRoot:     %{_tmppath}/%{name}-%{version}-root
#ExclusiveArch: i686 x86_64 ppc ppc64

%define __perl_requires %{SOURCE1}

%description
This package contains the a320raid kernel module.
Note that this driver does not licensed by the 
OpenSource(TM) term.

%package -n kernel-smp-driver-a320raid
Summary: A320raid (Adaptec close source driver) for smp kernel
Group: System Environment/Kernel
Prereq: kernel-smp-%{_target_cpu} = %{kver}-%{krpmver}

%description -n kernel-smp-driver-a320raid
This package contains the a320raid kernel module for smp kernel

%package -n kernel-hugemem-driver-a320raid
Summary: A320raid (Adaptec close source driver) for hugemem kernel
Group: System Environment/Kernel
Prereq: kernel-hugemem-%{_target_cpu} = %{kver}-%{krpmver}

%description -n kernel-hugemem-driver-a320raid
This package contains the a320raid kernel module for hugemem kernel

%package -n kernel-largesmp-driver-a320raid
Summary: A320raid (Adaptec close source driver) for largesmp kernel
Group: System Environment/Kernel
Prereq: kernel-largesmp-%{_target_cpu} = %{kver}-%{krpmver}

%description -n kernel-largesmp-driver-a320raid
This package contains the a320raid kernel module for largesmp kernel

%prep
%setup -q -c a320raid
%patch0 -p0
%patch1 -p0

## copy kernel tree for build
/bin/cp -a /usr/src/linux-%{kver}-%{krpmver} .
cd linux-%{kver}-%{krpmver}
## for safe
make clean
ln -s ../../../a320raid drivers/scsi/a320raid
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -prep/" Makefile
#perl -p -i -e "s/^NAME.*/NAME = Asianux/" Makefile
cd ..

%build
rm -rf $RPM_BUILD_ROOT
cd linux-%{kver}-%{krpmver}

BuildDriver() {
  KernelVer=%{kver}-%{krpmver}$1
  ModuleDir=$RPM_BUILD_ROOT/lib/modules/$KernelVer/kernel/drivers/scsi
  mkdir -p $ModuleDir
  perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{krpmver}$1/" Makefile
  if [ -n "$1" ]; then
    cp -a configs/kernel-%{kver}-%{_target_cpu}-$1.config .config
  else
    cp -a configs/kernel-%{kver}-%{_target_cpu}.config .config
  fi
  if [ ! -L include/asm ]; then
    ln -sf asm-%{_arch} include/asm
  fi
  make -s nonint_oldconfig >/dev/null
  make -s include/linux/version.h
  make scripts
  ln -sf ../a320raid/Makefile.k26.a320raid drivers/scsi/a320raid/Makefile
  make -s SUBDIRS=drivers/scsi/a320raid CONFIG_SCSI_A320RAID=m modules
  strip -g drivers/scsi/a320raid/a320raid.ko
  cp -a drivers/scsi/a320raid/a320raid.ko $ModuleDir
  rm -f drivers/scsi/a320raid/*o
  make clean
}

# Build driver for each kernels
BuildDriver
BuildDriver smp
%ifarch i686
BuildDriver hugemem
%endif
%ifarch ia64 x86_64
BuildDriver largesmp
%endif

cd ..

%install

%clean
rm -rf ${RPM_BUILD_ROOT}

%post
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}
exit 0

%post -n kernel-smp-driver-a320raid
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}smp
exit 0

%ifarch i686
%post -n kernel-hugemem-driver-a320raid
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}hugemem
exit 0
%endif

%ifarch ia64 x86_64
%post -n kernel-largesmp-driver-a320raid
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}largesmp
exit 0
%endif

%postun
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver} %{kver}-%{krpmver}
exit 0

%postun -n kernel-smp-driver-a320raid
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}smp %{kver}-%{krpmver}smp
exit 0

%ifarch i686
%postun -n kernel-hugemem-driver-a320raid
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}hugemem %{kver}-%{krpmver}hugemem
exit 0
%endif

%ifarch ia64 x86_64
%postun -n kernel-largesmp-driver-a320raid
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}largesmp %{kver}-%{krpmver}largesmp
exit 0
%endif

%files
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}/kernel/drivers/scsi/*

%files -n kernel-smp-driver-a320raid
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}smp/kernel/drivers/scsi/*

%ifarch i686
%files -n kernel-hugemem-driver-a320raid
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}hugemem/kernel/drivers/scsi/*
%endif

%ifarch ia64 x86_64
%files -n kernel-largesmp-driver-a320raid
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}largesmp/kernel/drivers/scsi/*
%endif

%changelog
* Fri Jan  8 2010 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.19AXS2

* Wed Dec  2 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.18AXS2

* Thu Nov 12 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.17AXS2

* Mon Sep 28 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.16AXS2

* Mon Sep 14 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.15AXS2

* Fri Jul 17 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.14AXS2

* Thu Jun 25 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.13AXS2

* Tue May 26 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.12AXS2

* Mon Apr 27 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.11AXS2

* Wed Apr  1 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.10AXS2

* Thu Feb  5 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.9AXS2

* Tue Dec 16 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.8AXS2

* Mon Dec 15 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.7AXS2

* Mon Dec  1 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.6AXS2

* Wed Nov 19 2008 Hidehiko MATSUMOTO <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-78.5AXS2

* Thu Nov 17 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.4AXS2

* Thu Oct 31 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- Update a320raid from 3.00.071-V580A2-1 to 3.00.074-V580A1-1

* Thu Oct 16 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.2AXS2

* Tue Sep 17 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-42.28AX

* Tue Aug 27 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-42.26AX

* Tue Jul 24 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-42.24AX

* Tue Jul 08 2008 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.23AX

* Tue May 27 2008 Robert Lin <robert@miraclelinux.com>
- rebuild for kernel-2.6.9-42.22AX

* Tue Apr  1 2008 Robert Lin <robert@miraclelinux.com>
- rebuild for kernel-2.6.9-42.21AX

* Mon Mar 10 2008 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.20AX

* Wed Dec  5 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.18AX

* Wed Oct 31 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.17AX

* Wed Sep 26 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.16AX

* Wed Jul 18 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.15AX

* Mon Jun 11 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.14AX

* Thu May 29 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.13AX

* Thu May  1 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.11AX

* Wed Mar 14 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.10AX

* Thu Feb 22 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.8AX

* Wed Jan 10 2007 Hiroshi Hara <hhara@miraclelinux.com>
- rebuild for kernel-2.6.9-42.7AX

* Tue Oct 10 2006 Hiroshi Hara <hhara@miraclelinux.com>
- rebuild for kernel-2.6.9-34.28AX

* Fri May 29 2006 Hiroshi Hara <hhara@miraclelinux.com>
- Update a320raid from 3.00.070-V580A1 to 3.00.071-V580A2-1
- to fix bugzillaAX #1579

* Wed May 17 2006 Shiro Yamada <shiro@miraclelinux.com> - 2.6.9_34.18AX_8
- rebuild for kernel-2.6.9-34.20AX

* Thu Apr 27 2006 Shiro Yamada <shiro@miraclelinux.com> - 2.6.9_34.17AX_7
- rebuild for kernel-2.6.9-34.17AX

* Thu Apr 13 2006 Shiro Yamada <shiro@miraclelinux.com>
- rebuild for 2.6.9-34.14AX
- deal with PreReq properly

* Tue Mar 28 2006 Shiro Yamada <shiro@miraclelinux.com>
- upgrade to 3.00.070
- add module for kernel-largesmp
- automatically identifies kernel release from its kernel-devel

* Mon Nov 28 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Strip -g

* Mon Nov 14 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Fix %post fail

* Tue Nov  1 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Change default write buffer flag

* Thu Oct 27 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Change package name scheme to kernel-<tag>-driver-<driver_name>

* Tue Oct 25 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Initial packaging

